
/* nide
*/
#include <stdio.h>
#include <stdlib.h>

char outFileName[] = "142480F.txt"; // vljundfaili nimi

void sisestus( double * x , double * e)
{
    do
    {
        printf("Sisesta reaalarvuline X (|X| < 1): ");
        scanf("%lf",x);
    }while( !(-1 < *x && *x < 1) );
    do
    {
        printf("Sisesta reaalarvuline e (0 < e < 1): ");
        scanf("%lf", e);
    }while( !( 0 < *e && *e < 1) );
}

double power(double a , int b)  // arvutab a^b  , vtab arvu a astmele b
{
    if( b > 0 )
    {
        return a * power( a, b - 1);
    }
    else return 1;
}

void push(double * stack , int * n , float value)   // lisab stack'i
{
    double * temp = realloc(stack, sizeof(double)*(*n + 1));    // proovib eraldada mlu
    if( temp == NULL )  // kontrollib, kas mlu eraldamine nnestus
    {
        printf("Ei nnestunud mlu eraldada.\n");
        return; // vljub funktsioonist
    }
    stack = temp;
    *n = *n + 1;
    *(stack + (*n) - 1) = value;

    printf("%d) %.15lf \t %x\n", *n,*(stack + (*n) - 1), stack + *n);   // prindib sisestatud arvu + tema mlu aadressi
}

double absolute(double value)	// arvutab absoluutvrtuse
{
    if( value < 0 ) return -1.0f*value;
    else return value;
}

// igal korral saadan edasi eelmise vastuse
void rekursiiv( double * massiiv, int * n, double v , double x, double e)
{
    double vahe = *(massiiv - *n - 1) - *(massiiv - *n - 2);
    if( (*n) + 1 <= 15 && absolute( vahe ) <= e )   // kontrolli tingimust
    {
        v *= (((*n) + 1)*2 - 3)/((double)((*n) + 1)*2 - 2);	// arvutab v22rtuse, mis saadab edasi rekursiivi()
    	double vv = v * power(x, ((*n) + 1)*2 - 1) / ((double)(((*n) + 1))*2 - 1);	// arvutab massiivi v22rtuse
    	push(massiiv, n, vv);   // lisab arvutatud vrtuse massiivi
        rekursiiv(massiiv, n, v, x, e);
    }
}

void valjastus( double * stack , int n )
{
    // loo fail
    FILE * out = fopen( outFileName, "w" );

    // kirjuta faili andmed
    fprintf(out,"Elementide arv: %d\n", n);
    int i;
    for(i=0;i<n;i++)
    {
        fprintf(out,"%d) %.15lf\n", i, *(stack + i));
    }

    // sulgeme faili
    fclose( out );
}

int main( void )
{
    // deklareerimine
    double x;
    double e;
    double * A = malloc( sizeof(double) * 0 );
    int n = 0;  // hoiab jrge, kuhu sisestatakse jrgnev vrtus ( massiivi pointer ) / sisestatud vrtuste hulk

    sisestus(&x,&e);

    // ttlus
    push(A, &n, x);
    rekursiiv(A, &n, 1, x, e);
    // vljastus
    valjastus( A, n );

    return 0;
}
